/*
 * ListsHandler.java
 *
 * Created on 10 de agosto de 2004, 17:54
 */

package com.fenalco.servlets.shopkeeper;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.Log;
import com.fenalco.entities.ShoppingCart;
import com.fenalco.entities.ShoppingList;
import com.fenalco.entities.Store;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.database.Transaction;

/**
 * 
 * Este servlet administra las operaciones cargar , eliminar que se realicen
 * sobre las listas de compra del minorista. Recibe el parámetro <CODE>
 * operationType</CODE> de mislistas.jsp que indica el tipo de operación a
 * realizar y el parámetro <CODE>shoppingListId</CODE> que indica el id de la
 * lista de compra sobre la cual se va a realizar la operación .
 * 
 * @author Mario Linares
 */
public class ListsHandler extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 * @throws ServletException
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destructor de el servlet
	 */
	public void destroy( )
	{

	}

	/**
	 * Este método procesa las solicitudes de los métodos HTTP <code>GET</code>
	 * y <code>POST</code>. Realiza operaciones de acuerdo con la selección
	 * realizada por el minorista: -<CODE>operationType</CODE>= load
	 * Construye una instancia de la clase <CODE>ShoppingList</CODE> con el
	 * parámetro <CODE>id</CODE> e invoca el método <CODE>loadListSession
	 * </CODE> que retorna un <CODE>ShoppingCart</CODE> que debe ser agregado
	 * a la sesión y luego redirecciona al servlet /micarrito -<CODE>
	 * operationType</CODE>= delete Construye una instancia de la clase <CODE>
	 * ShoppingList</CODE> con el parámetro <CODE>id</CODE> del <CODE>
	 * request</CODE>, luego invoca la función miembro <CODE>delete</CODE> y
	 * redireciona al servlet /mislistas.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		String url = "/minorista/mislistas";
        HttpSession session = request.getSession( false );
        String message = "";

	    try
	    {
	        if( session != null && ( User )session.getAttribute( "user" ) != null && ( ( User )session.getAttribute( "user" ) ).getRoleId() == 3 )
			{
	
				String operation = request.getParameter("operationType");
	
				if( operation.equals("load") )
				{
					int listId = Integer.parseInt(request.getParameter("id"));
					ShoppingList list = new ShoppingList(listId);
	
					Store store = (Store) request.getSession()
							.getAttribute("store");
					int storeId = store.getId();
	
					ShoppingCart cart = list.loadListSession(storeId);
	
					request.getSession().setAttribute("cart", cart);
					url = "/minorista/micarrito";
				}
				else
					if( operation.equals("delete") )
					{
						String[] items = request.getParameterValues("item");
						if( items != null )
						{
							Transaction transaction = new Transaction();
							for( int i = 0; i < items.length; i++ )
							{
								ShoppingList tempList = new ShoppingList(Integer
										.parseInt(items[i]));
								tempList.delete(transaction);
	
                                                                try
                                                                {
                                                                    Transaction t = new Transaction( );
                                                                    Log l = new Log( );
                                                                                                User user = ( User )session.getAttribute( "user" );
                                                                    String userId = user.getLogin();
                                                                    String numberId = user.getIdentificationNumber();
                                                                    String externalUser = "";
                                                                    User callcenter = ( User )session.getAttribute( "callcenter" );
                                                                    String description = "Eliminación de la lista " + tempList.getListName();
                                                                    if( callcenter != null )
                                                                    {
                                                                        externalUser = callcenter.getLogin();
                                                                    }
                                                                                                l.saveData(userId, numberId, 7, description, externalUser, t );
                                                                    t.execute();
                                                                }
                                                                catch( Exception ex )
                                                                {
                                                                    System.out.println( "Error guardando el Log." );
                                                                }
							}
							transaction.execute();
							message = "Las listas seleccionadas fueron eliminadas exitosamente";
							// guardo el registro en el log
	
						}
	
					}
			}
			else
			{
				message = MessageBuilder.buildMessage(15);
				url = "/index.jsp";
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }
		request.setAttribute("message", message);
		RequestDispatcher dispatcher = getServletContext()
				.getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Procesa el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Procesa el método HTTP <code>POST</code> method.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una breve descripción de el servlet.
	 * 
	 * @return
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}